function [perf] = analyse_classification(ro,states,stimuli)

X = vertcat(states(:).X);

tmp(length(stimuli)).y = [];
for i=1:length(stimuli)
  tmp(i).y = target_values(get(ro,'targetFunction'),stimuli(i),states(i).t);
end
Y = vertcat(tmp(:).y);
clear tmp


undef = find(isnan(Y));
X(undef,:) = [];
Y(undef)   = [];

alg = get(ro,'algorithm');
preproc = get(ro,'preprocess');
r = get(alg,'range');
Y = (Y-preproc.b)/preproc.a*diff(r)+r(1);


Y = sign(Y);

if prod(size(Y)) > 0
  scale = abs(diff(r));

  O     = sign(apply(ro,X)*diff(r) + r(1));
  mae   = mean(abs(O-Y))/2;
  mse   = mean((O-Y).^2)/4;
  cc    = corr_coef(O,Y);
  CM    = confusion_matrix(O,Y,[-1 1]);
  score = CM(1,2)/(1+CM(1,1))+CM(2,1)/(1+CM(2,2));
else
  mae = NaN; mse=NaN; cc=NaN; score=NaN;
end

perf.cc = cc;
perf.mae = mae;
perf.mse = mse;
perf.score = score;
